Index: issm/trunk/src/c/classes/Elements/Penta.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Penta.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Penta.cpp	(revision 18301)
@@ -25,6 +25,5 @@
 /*}}}*/
 Penta::Penta(int penta_id, int penta_sid, int index, IoModel* iomodel,int nummodels)/*{{{*/
-	:PentaRef(nummodels)
-	,ElementHook(nummodels,index+1,NUMVERTICES,iomodel){
+	:ElementHook(nummodels,index+1,NUMVERTICES,iomodel){
 
 	int penta_elements_ids[2];
@@ -35,6 +34,6 @@
 
 	/*id: */
-	this->id=penta_id;
-	this->sid=penta_sid;
+	this->id  = penta_id;
+	this->sid = penta_sid;
 
 	/*Build neighbors list*/
@@ -57,4 +56,7 @@
 	this->matpar            = NULL;
 	this->verticalneighbors = NULL;
+
+	/*Only allocate pointer*/
+	this->element_type_list=xNew<int>(nummodels);
 }
 /*}}}*/
@@ -62,5 +64,4 @@
 
 	int i;
-
 	Penta* penta=NULL;
 
@@ -68,37 +69,56 @@
 
 	//deal with PentaRef mother class
-	penta->element_type_list=xNew<int>(this->numanalyses);
-	for(i=0;i<this->numanalyses;i++) penta->element_type_list[i]=this->element_type_list[i];
-
-	//deal with ElementHook
-	penta->numanalyses=this->numanalyses;
-	penta->hnodes=new Hook*[penta->numanalyses];
-	for(i=0;i<penta->numanalyses;i++)penta->hnodes[i]=(Hook*)this->hnodes[i]->copy();
-	penta->hvertices=(Hook*)this->hvertices->copy();
-	penta->hmaterial=(Hook*)this->hmaterial->copy();
-	penta->hmatpar=(Hook*)this->hmatpar->copy();
-	penta->hneighbors=(Hook*)this->hneighbors->copy();
-
-	/*deal with Penta  copy fields: */
-	penta->id=this->id;
-	penta->sid=this->sid;
-	if(this->inputs){
-		penta->inputs=(Inputs*)this->inputs->Copy();
-	}
-	else{
-		penta->inputs=new Inputs();
-	}
+	int nanalyses = this->numanalyses;
+	if(nanalyses > 0){
+		penta->element_type_list=xNew<int>(nanalyses);
+		for(i=0;i<nanalyses;i++) {
+			if (this->element_type_list[i]) penta->element_type_list[i]=this->element_type_list[i];
+			else penta->element_type_list[i] = 0;
+		}
+	}
+	else penta->element_type_list = NULL;
+	penta->element_type=this->element_type;
+	penta->numanalyses=nanalyses;
+
+	//deal with ElementHook mother class
+	if (this->hnodes){
+		penta->hnodes=xNew<Hook*>(penta->numanalyses);
+		for(i=0;i<penta->numanalyses;i++){
+			if (this->hnodes[i]) penta->hnodes[i] = (Hook*)(this->hnodes[i]->copy());
+			else penta->hnodes[i] = NULL;
+		}
+	}
+	else penta->hnodes = NULL;
+
+	penta->hvertices = (Hook*)this->hvertices->copy();
+	penta->hmaterial = (Hook*)this->hmaterial->copy();
+	penta->hmatpar   = (Hook*)this->hmatpar->copy();
+	if (this->hneighbors) penta->hneighbors = (Hook*)(this->hneighbors->copy());
+	else penta->hneighbors = NULL;
+
+	/*deal with Tria fields: */
+	penta->id  = this->id;
+	penta->sid = this->sid;
+	if(this->inputs) penta->inputs = (Inputs*)(this->inputs->Copy());
+	else penta->inputs=new Inputs();
+
 	/*point parameters: */
 	penta->parameters=this->parameters;
 
 	/*recover objects: */
-	penta->nodes=xNew<Node*>(6); //we cannot rely on an analysis_counter to tell us which analysis_type we are running, so we just copy the nodes.
-	for(i=0;i<6;i++)penta->nodes[i]=this->nodes[i];
-	penta->vertices=(Vertex**)penta->hvertices->deliverp();
-	penta->material=(Material*)penta->hmaterial->delivers();
-	penta->matpar=(Matpar*)penta->hmatpar->delivers();
-	penta->verticalneighbors=(Penta**)penta->hneighbors->deliverp();
+	if (this->nodes) {
+		unsigned int num_nodes = 6;
+		penta->nodes = xNew<Node*>(num_nodes); //we cannot rely on an analysis_counter to tell us which analysis_type we are running, so we just copy the nodes.
+		for(i=0;i<num_nodes;i++) if(this->nodes[i]) penta->nodes[i]=this->nodes[i]; else penta->nodes[i] = NULL;
+	}
+	else penta->nodes = NULL;
+
+	penta->vertices = (Vertex**)this->hvertices->deliverp();
+	penta->material = (Material*)this->hmaterial->delivers();
+	penta->matpar   = (Matpar*)this->hmatpar->delivers();
+	penta->verticalneighbors = (Penta**)this->hneighbors->deliverp();
 
 	return penta;
+
 }
 /*}}}*/
@@ -223,52 +243,4 @@
 }
 /*}}}*/
-void       Penta::ComputeStrainRate(){/*{{{*/
-
-	IssmDouble      xyz_list[NUMVERTICES][3];
-	IssmDouble      epsilon[6]; /* epsilon=[exx,eyy,exy];*/
-	IssmDouble      eps_xx[NUMVERTICES];
-	IssmDouble		 eps_yy[NUMVERTICES];
-	IssmDouble		 eps_zz[NUMVERTICES];
-	IssmDouble      eps_xy[NUMVERTICES];
-	IssmDouble		 eps_xz[NUMVERTICES];
-	IssmDouble		 eps_yz[NUMVERTICES];
-	GaussPenta*     gauss=NULL;
-
-	/* Get node coordinates and dof list: */
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-
-	/*Retrieve all inputs we will be needing: */
-	Input* vx_input=inputs->GetInput(VxEnum);             _assert_(vx_input);
-	Input* vy_input=inputs->GetInput(VyEnum);             _assert_(vy_input);
-	Input* vz_input=inputs->GetInput(VzEnum);             _assert_(vz_input);
-
-	/* Start looping on the number of vertices: */
-	gauss=new GaussPenta();
-	for (int iv=0;iv<NUMVERTICES;iv++){
-		gauss->GaussVertex(iv);
-
-		/*Compute strain rate viscosity and pressure: */
-		this->StrainRateFS(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input,vz_input);
-
-		eps_xx[iv]=epsilon[0]; 
-		eps_yy[iv]=epsilon[1];
-		eps_zz[iv]=epsilon[2];
-		eps_xy[iv]=epsilon[3];
-		eps_xz[iv]=epsilon[4];
-		eps_yz[iv]=epsilon[5];
-	}
-
-	/*Add Stress tensor components into inputs*/
-	this->inputs->AddInput(new PentaInput(StrainRatexxEnum,&eps_xx[0],P1Enum));
-	this->inputs->AddInput(new PentaInput(StrainRatexyEnum,&eps_xy[0],P1Enum));
-	this->inputs->AddInput(new PentaInput(StrainRatexzEnum,&eps_xz[0],P1Enum));
-	this->inputs->AddInput(new PentaInput(StrainRateyyEnum,&eps_yy[0],P1Enum));
-	this->inputs->AddInput(new PentaInput(StrainRateyzEnum,&eps_yz[0],P1Enum));
-	this->inputs->AddInput(new PentaInput(StrainRatezzEnum,&eps_zz[0],P1Enum));
-
-	/*Clean up and return*/
-	delete gauss;
-}
-/*}}}*/
 void       Penta::ComputeStressTensor(){/*{{{*/
 
@@ -869,5 +841,5 @@
 
 	_assert_(nodes);
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(this->element_type);
 
 	for(int i=0;i<numnodes;i++){
@@ -879,5 +851,9 @@
 /*}}}*/
 int        Penta::GetNumberOfNodes(void){/*{{{*/
-	return this->NumberofNodes();
+	return this->NumberofNodes(this->element_type);
+}
+/*}}}*/
+int        Penta::GetNumberOfNodes(int enum_type){/*{{{*/
+	return this->NumberofNodes(enum_type);
 }
 /*}}}*/
@@ -886,7 +862,7 @@
 }
 /*}}}*/
-Node* Penta::GetNode(int node_number){/*{{{*/
+Node*      Penta::GetNode(int node_number){/*{{{*/
 	_assert_(node_number>=0); 
-	_assert_(node_number<this->NumberofNodes()); 
+	_assert_(node_number<this->NumberofNodes(this->element_type)); 
 	return this->nodes[node_number];
 }
@@ -1169,5 +1145,5 @@
 		/*Step3: Vertically integrate A COPY of the original*/
 		if(original_input->ObjectEnum()==PentaInputEnum){
-			if(((PentaInput*)original_input)->element_type==P0Enum){
+			if(((PentaInput*)original_input)->interpolation_type==P0Enum){
 				original_input->GetInputValue(&p0top1_list[i]);
 				element_integrated_input= new  PentaInput(original_input->InstanceEnum(),p0top1_list,P1Enum);
@@ -1358,5 +1334,5 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(this->element_type);
 
 	/*Fetch dof list and allocate solution vector*/
@@ -1512,5 +1488,5 @@
 }
 /*}}}*/
-bool   Penta::IsNodeOnShelfFromFlags(IssmDouble* flags){/*{{{*/
+bool       Penta::IsNodeOnShelfFromFlags(IssmDouble* flags){/*{{{*/
 
 	int  i;
@@ -1582,5 +1558,5 @@
 }
 /*}}}*/
-int    Penta::NodalValue(IssmDouble* pvalue, int index, int natureofdataenum){/*{{{*/
+int        Penta::NodalValue(IssmDouble* pvalue, int index, int natureofdataenum){/*{{{*/
 
 	int i;
@@ -1613,13 +1589,13 @@
 }
 /*}}}*/
-Gauss* Penta::NewGauss(void){/*{{{*/
+Gauss*     Penta::NewGauss(void){/*{{{*/
 	return new GaussPenta();
 }
 /*}}}*/
-Gauss* Penta::NewGauss(int order){/*{{{*/
+Gauss*     Penta::NewGauss(int order){/*{{{*/
 	return new GaussPenta(order,order);
 }
 /*}}}*/
-Gauss* Penta::NewGauss(IssmDouble* xyz_list, IssmDouble* xyz_list_front,int order_horiz,int order_vert){/*{{{*/
+Gauss*     Penta::NewGauss(IssmDouble* xyz_list, IssmDouble* xyz_list_front,int order_horiz,int order_vert){/*{{{*/
 
 	IssmDouble  area_coordinates[4][3];
@@ -1630,13 +1606,13 @@
 }
 /*}}}*/
-Gauss* Penta::NewGaussBase(int order){/*{{{*/
+Gauss*     Penta::NewGaussBase(int order){/*{{{*/
 	return new GaussPenta(0,1,2,order);
 }
 /*}}}*/
-Gauss* Penta::NewGaussLine(int vertex1,int vertex2,int order){/*{{{*/
+Gauss*     Penta::NewGaussLine(int vertex1,int vertex2,int order){/*{{{*/
 	return new GaussPenta(vertex1,vertex2,order);
 }
 /*}}}*/
-Gauss* Penta::NewGaussTop(int order){/*{{{*/
+Gauss*     Penta::NewGaussTop(int order){/*{{{*/
 	return new GaussPenta(3,4,5,order);
 }
@@ -1645,5 +1621,5 @@
 
 	_assert_(gauss->Enum()==GaussPentaEnum);
-	this->GetNodalFunctions(basis,(GaussPenta*)gauss);
+	this->GetNodalFunctions(basis,(GaussPenta*)gauss,this->element_type);
 
 }
@@ -1652,5 +1628,12 @@
 
 	_assert_(gauss->Enum()==GaussPentaEnum);
-	this->GetNodalFunctionsP1(basis,(GaussPenta*)gauss);
+	this->GetNodalFunctions(basis,(GaussPenta*)gauss,P1Enum);
+
+}
+/*}}}*/
+void       Penta::NodalFunctionsP2(IssmDouble* basis, Gauss* gauss){/*{{{*/
+
+	_assert_(gauss->Enum()==GaussPentaEnum);
+	this->GetNodalFunctions(basis,(GaussPenta*)gauss,P2Enum);
 
 }
@@ -1659,5 +1642,5 @@
 
 	_assert_(gauss->Enum()==GaussPentaEnum);
-	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussPenta*)gauss);
+	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussPenta*)gauss,this->element_type);
 
 }
@@ -1666,5 +1649,5 @@
 
 	_assert_(gauss->Enum()==GaussPentaEnum);
-	this->GetNodalFunctionsP1Derivatives(dbasis,xyz_list,(GaussPenta*)gauss);
+	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussPenta*)gauss,P1Enum);
 
 }
@@ -1673,5 +1656,5 @@
 
 	_assert_(gauss->Enum()==GaussPentaEnum);
-	this->GetNodalFunctionsMINIDerivatives(dbasis,xyz_list,(GaussPenta*)gauss);
+	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussPenta*)gauss,P1bubbleEnum);
 
 }
@@ -1946,4 +1929,22 @@
 }
 /*}}}*/
+void       Penta::ResetHooks(){/*{{{*/
+
+	this->nodes=NULL;
+	this->vertices=NULL;
+	this->material=NULL;
+	this->matpar=NULL;
+	this->verticalneighbors=NULL;
+	this->parameters=NULL;
+
+	//deal with ElementHook mother class
+	for(int i=0;i<this->numanalyses;i++) if(this->hnodes[i]) this->hnodes[i]->reset();
+	this->hvertices->reset();
+	this->hmaterial->reset();
+	this->hmatpar->reset();
+	if(this->hneighbors) this->hneighbors->reset();
+
+}
+/*}}}*/
 void       Penta::SetTemporaryElementType(int element_type_in){/*{{{*/
 	this->element_type=element_type_in;
@@ -2003,49 +2004,4 @@
 }
 /*}}}*/
-void       Penta::SmbGradients(void){/*{{{*/
-
-	int i;
-
-	// input
-   IssmDouble h[NUMVERTICES];					// ice thickness (m)		
-	IssmDouble s[NUMVERTICES];					// surface elevation (m)
-	IssmDouble b_pos[NUMVERTICES];				// Hs-SMB relation parameter
-	IssmDouble b_neg[NUMVERTICES];				// Hs-SMB relation paremeter
-	IssmDouble Href[NUMVERTICES];					// reference elevation from which deviations are used to calculate the SMB adjustment
-	IssmDouble Smbref[NUMVERTICES];				// reference SMB to which deviations are added
-   IssmDouble rho_water;                   // density of fresh water
-	IssmDouble rho_ice;                     // density of ice
-
-	// output
-	IssmDouble smb[NUMVERTICES];					// surface mass balance (m/yr ice)
-
-	/*Recover SmbGradients*/
-	GetInputListOnVertices(&Href[0],SurfaceforcingsHrefEnum);
-	GetInputListOnVertices(&Smbref[0],SurfaceforcingsSmbrefEnum);
-	GetInputListOnVertices(&b_pos[0],SurfaceforcingsBPosEnum);
-	GetInputListOnVertices(&b_neg[0],SurfaceforcingsBNegEnum);
-
-   /*Recover surface elevatio at vertices: */
-	GetInputListOnVertices(&h[0],ThicknessEnum);
-	GetInputListOnVertices(&s[0],SurfaceEnum);
-
-   /*Get material parameters :*/
-   rho_ice=matpar->GetRhoIce();
-   rho_water=matpar->GetRhoFreshwater();
-
-   // loop over all vertices
- for(i=0;i<NUMVERTICES;i++){
-     if(Smbref[i]>0){
-		  smb[i]=Smbref[i]+b_pos[i]*(s[i]-Href[i]);
-	  }
-	  else{
-		  smb[i]=Smbref[i]+b_neg[i]*(s[i]-Href[i]);
-	  }
-	  smb[i]=smb[i]/rho_ice;      // SMB in m/y ice		
-	}  //end of the loop over the vertices
-	  /*Update inputs*/
-	  this->inputs->AddInput(new PentaInput(SurfaceforcingsMassBalanceEnum,&smb[0],P1Enum));
-}
-/*}}}*/
 IssmDouble Penta::SurfaceArea(void){/*{{{*/
 
@@ -2096,7 +2052,7 @@
 
 	/*Get for Vx and Vy, the max of abs value: */
-	this->MaxAbsVx(&maxabsvx);
-	this->MaxAbsVy(&maxabsvy);
-	this->MaxAbsVz(&maxabsvz);
+	maxabsvx = this->inputs->MaxAbs(VxEnum);
+	maxabsvy = this->inputs->MaxAbs(VyEnum);
+	maxabsvz = this->inputs->MaxAbs(VzEnum);
 
 	/* Get node coordinates and dof list: */
@@ -2148,5 +2104,5 @@
 
 	/*Recover element type*/
-	this->SetElementType(finiteelement_type,analysis_counter);
+	this->element_type_list[analysis_counter]=finiteelement_type;
 
 	/*Recover vertices ids needed to initialize inputs*/
@@ -2277,4 +2233,27 @@
 			penta_node_ids[17]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+4]+1;
 			break;
+		case P2bubbleEnum: case P2bubblecondensedEnum:
+			numnodes         = 19;
+			penta_node_ids   = xNew<int>(numnodes);
+			penta_node_ids[ 0]=iomodel->nodecounter+iomodel->elements[6*index+0];
+			penta_node_ids[ 1]=iomodel->nodecounter+iomodel->elements[6*index+1];
+			penta_node_ids[ 2]=iomodel->nodecounter+iomodel->elements[6*index+2];
+			penta_node_ids[ 3]=iomodel->nodecounter+iomodel->elements[6*index+3];
+			penta_node_ids[ 4]=iomodel->nodecounter+iomodel->elements[6*index+4];
+			penta_node_ids[ 5]=iomodel->nodecounter+iomodel->elements[6*index+5];
+			penta_node_ids[ 6]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+0]+1;
+			penta_node_ids[ 7]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+1]+1;
+			penta_node_ids[ 8]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+2]+1;
+			penta_node_ids[ 9]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+3]+1;
+			penta_node_ids[10]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+4]+1;
+			penta_node_ids[11]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+5]+1;
+			penta_node_ids[12]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+6]+1;
+			penta_node_ids[13]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+7]+1;
+			penta_node_ids[14]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+8]+1;
+			penta_node_ids[15]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+2]+1;
+			penta_node_ids[16]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+3]+1;
+			penta_node_ids[17]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+4]+1;
+			penta_node_ids[18]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+index+1;
+			break;
 		case P1P1Enum: case P1P1GLSEnum:
 			numnodes         = 12;
@@ -2340,4 +2319,26 @@
 			penta_node_ids[22]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+iomodel->elements[6*index+4];
 			penta_node_ids[23]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+iomodel->elements[6*index+5];
+			break;
+		case LATaylorHoodEnum:
+			numnodes         = 18;
+			penta_node_ids   = xNew<int>(numnodes);
+			penta_node_ids[ 0]=iomodel->nodecounter+iomodel->elements[6*index+0];
+			penta_node_ids[ 1]=iomodel->nodecounter+iomodel->elements[6*index+1];
+			penta_node_ids[ 2]=iomodel->nodecounter+iomodel->elements[6*index+2];
+			penta_node_ids[ 3]=iomodel->nodecounter+iomodel->elements[6*index+3];
+			penta_node_ids[ 4]=iomodel->nodecounter+iomodel->elements[6*index+4];
+			penta_node_ids[ 5]=iomodel->nodecounter+iomodel->elements[6*index+5];
+			penta_node_ids[ 6]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+0]+1;
+			penta_node_ids[ 7]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+1]+1;
+			penta_node_ids[ 8]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+2]+1;
+			penta_node_ids[ 9]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+3]+1;
+			penta_node_ids[10]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+4]+1;
+			penta_node_ids[11]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+5]+1;
+			penta_node_ids[12]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+6]+1;
+			penta_node_ids[13]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+7]+1;
+			penta_node_ids[14]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+8]+1;
+			penta_node_ids[15]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+2]+1;
+			penta_node_ids[16]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+3]+1;
+			penta_node_ids[17]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+4]+1;
 			break;
 		case OneLayerP4zEnum:
@@ -2382,4 +2383,34 @@
 			penta_node_ids[35]=iomodel->nodecounter+iomodel->numberofvertices+3*iomodel->numberofedges+3*iomodel->numberoffaces+iomodel->elements[6*index+5];
 			break;
+		case CrouzeixRaviartEnum:
+			numnodes         = 25;
+			penta_node_ids   = xNew<int>(numnodes);
+			penta_node_ids[ 0]=iomodel->nodecounter+iomodel->elements[6*index+0];
+			penta_node_ids[ 1]=iomodel->nodecounter+iomodel->elements[6*index+1];
+			penta_node_ids[ 2]=iomodel->nodecounter+iomodel->elements[6*index+2];
+			penta_node_ids[ 3]=iomodel->nodecounter+iomodel->elements[6*index+3];
+			penta_node_ids[ 4]=iomodel->nodecounter+iomodel->elements[6*index+4];
+			penta_node_ids[ 5]=iomodel->nodecounter+iomodel->elements[6*index+5];
+			penta_node_ids[ 6]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+0]+1;
+			penta_node_ids[ 7]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+1]+1;
+			penta_node_ids[ 8]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+2]+1;
+			penta_node_ids[ 9]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+3]+1;
+			penta_node_ids[10]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+4]+1;
+			penta_node_ids[11]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+5]+1;
+			penta_node_ids[12]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+6]+1;
+			penta_node_ids[13]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+7]+1;
+			penta_node_ids[14]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[9*index+8]+1;
+			penta_node_ids[15]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+2]+1;
+			penta_node_ids[16]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+3]+1;
+			penta_node_ids[17]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elementtofaceconnectivity[5*index+4]+1;
+			penta_node_ids[18]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+index+1;
+
+			penta_node_ids[19]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+iomodel->numberofelements+6*index+1;
+			penta_node_ids[20]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+iomodel->numberofelements+6*index+2;
+			penta_node_ids[21]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+iomodel->numberofelements+6*index+3;
+			penta_node_ids[22]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+iomodel->numberofelements+6*index+4;
+			penta_node_ids[23]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+iomodel->numberofelements+6*index+5;
+			penta_node_ids[24]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberoffaces+iomodel->numberofelements+6*index+6;
+			break;
 		default:
 			_error_("Finite element "<<EnumToStringx(finiteelement_type)<<" not supported yet");
@@ -2445,5 +2476,5 @@
 
 	GaussPenta* gauss=new GaussPenta();
-	for(int iv=0;iv<this->NumberofNodes();iv++){
+	for(int iv=0;iv<this->NumberofNodes(this->element_type);iv++){
 		gauss->GaussNode(this->element_type,iv);
 		onbase->GetInputValue(&isonbase,gauss);
@@ -2483,5 +2514,5 @@
 /*}}}*/
 void       Penta::ValueP1DerivativesOnGauss(IssmDouble* dvalue,IssmDouble* values,IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
-	PentaRef::GetInputDerivativeValue(dvalue,values,xyz_list,gauss);
+	PentaRef::GetInputDerivativeValue(dvalue,values,xyz_list,gauss,P1Enum);
 }
 /*}}}*/
@@ -2521,9 +2552,9 @@
 /*}}}*/
 int        Penta::VelocityInterpolation(void){/*{{{*/
-	return PentaRef::VelocityInterpolation();
+	return PentaRef::VelocityInterpolation(this->element_type);
 }
 /*}}}*/
 int        Penta::PressureInterpolation(void){/*{{{*/
-	return PentaRef::PressureInterpolation();
+	return PentaRef::PressureInterpolation(this->element_type);
 }
 /*}}}*/
@@ -2621,40 +2652,4 @@
 }
 /*}}}*/
-void       Penta::MinVel(IssmDouble* pminvel){/*{{{*/
-
-	/*Get minimum:*/
-	IssmDouble minvel=this->inputs->Min(VelEnum);
-
-	/*Assign output pointers:*/
-	*pminvel=minvel;
-}
-/*}}}*/
-void       Penta::MinVx(IssmDouble* pminvx){/*{{{*/
-
-	/*Get minimum:*/
-	IssmDouble minvx=this->inputs->Min(VxEnum);
-
-	/*Assign output pointers:*/
-	*pminvx=minvx;
-}
-/*}}}*/
-void       Penta::MinVy(IssmDouble* pminvy){/*{{{*/
-
-	/*Get minimum:*/
-	IssmDouble minvy=this->inputs->Min(VyEnum);
-
-	/*Assign output pointers:*/
-	*pminvy=minvy;
-}
-/*}}}*/
-void       Penta::MinVz(IssmDouble* pminvz){/*{{{*/
-
-	/*Get minimum:*/
-	IssmDouble minvz=this->inputs->Min(VzEnum);
-
-	/*Assign output pointers:*/
-	*pminvz=minvz;
-}
-/*}}}*/
 IssmDouble Penta::MassFlux( IssmDouble* segment){/*{{{*/
 
@@ -2701,68 +2696,4 @@
 	/*clean up and return*/
 	return mass_flux;
-}
-/*}}}*/
-void       Penta::MaxAbsVx(IssmDouble* pmaxabsvx){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxabsvx=this->inputs->MaxAbs(VxEnum);
-
-	/*Assign output pointers:*/
-	*pmaxabsvx=maxabsvx;
-}
-/*}}}*/
-void       Penta::MaxAbsVy(IssmDouble* pmaxabsvy){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxabsvy=this->inputs->MaxAbs(VyEnum);
-
-	/*Assign output pointers:*/
-	*pmaxabsvy=maxabsvy;
-}
-/*}}}*/
-void       Penta::MaxAbsVz(IssmDouble* pmaxabsvz){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxabsvz=this->inputs->MaxAbs(VzEnum);
-
-	/*Assign output pointers:*/
-	*pmaxabsvz=maxabsvz;
-}
-/*}}}*/
-void       Penta::MaxVel(IssmDouble* pmaxvel){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxvel=this->inputs->Max(VelEnum);
-
-	/*Assign output pointers:*/
-	*pmaxvel=maxvel;
-
-}
-/*}}}*/
-void       Penta::MaxVx(IssmDouble* pmaxvx){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxvx=this->inputs->Max(VxEnum);
-
-	/*Assign output pointers:*/
-	*pmaxvx=maxvx;
-}
-/*}}}*/
-void       Penta::MaxVy(IssmDouble* pmaxvy){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxvy=this->inputs->Max(VyEnum);
-
-	/*Assign output pointers:*/
-	*pmaxvy=maxvy;
-}
-/*}}}*/
-void       Penta::MaxVz(IssmDouble* pmaxvz){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxvz=this->inputs->Max(VzEnum);
-
-	/*Assign output pointers:*/
-	*pmaxvz=maxvz;
 }
 /*}}}*/
@@ -2833,45 +2764,4 @@
 #endif
 
-void       Penta::ControlInputGetGradient(Vector<IssmDouble>* gradient,int enum_type,int control_index){/*{{{*/
-
-	int vertexpidlist[NUMVERTICES];
-	Input* input=NULL;
-
-	if(enum_type==MaterialsRheologyBbarEnum){
-		if(!IsOnBase()) return;
-		input=(Input*)inputs->GetInput(MaterialsRheologyBEnum);
-	}
-	else if(enum_type==DamageDbarEnum){
-		if(!IsOnBase()) return;
-		input=(Input*)inputs->GetInput(DamageDEnum);
-	}
-	else{
-		input=inputs->GetInput(enum_type);
-	}
-	if (!input) _error_("Input " << EnumToStringx(enum_type) << " not found");
-	if (input->ObjectEnum()!=ControlInputEnum) _error_("Input " << EnumToStringx(enum_type) << " is not a ControlInput");
-
-	GradientIndexing(&vertexpidlist[0],control_index);
-	((ControlInput*)input)->GetGradient(gradient,&vertexpidlist[0]);
-
-}/*}}}*/
-void       Penta::ControlInputScaleGradient(int enum_type,IssmDouble scale){/*{{{*/
-
-	Input* input=NULL;
-
-	if(enum_type==MaterialsRheologyBbarEnum){
-		input=(Input*)inputs->GetInput(MaterialsRheologyBEnum);
-	}
-	else if(enum_type==DamageDbarEnum){
-		input=(Input*)inputs->GetInput(DamageDEnum);
-	}
-	else{
-		input=inputs->GetInput(enum_type);
-	}
-	if (!input) _error_("Input " << EnumToStringx(enum_type) << " not found");
-	if (input->ObjectEnum()!=ControlInputEnum) _error_("Input " << EnumToStringx(enum_type) << " is not a ControlInput");
-
-	((ControlInput*)input)->ScaleGradient(scale);
-}/*}}}*/
 void       Penta::ControlInputSetGradient(IssmDouble* gradient,int enum_type,int control_index){/*{{{*/
 
